/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.community.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import org.springblade.community.dto.AgencyMngDelDTO;
import org.springblade.community.entity.Room;
import org.springblade.community.vo.RoomVO;
import org.springblade.community.mapper.RoomMapper;
import org.springblade.community.service.IRoomService;
import org.springblade.core.mp.base.BaseServiceImpl;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.core.metadata.IPage;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * 房间表 服务实现类
 *
 * @author BladeX
 * @since 2021-03-29
 */
@Service
public class RoomServiceImpl extends BaseServiceImpl<RoomMapper, Room> implements IRoomService {

	@Override
	public IPage<RoomVO> selectRoomPage(IPage<RoomVO> page, RoomVO room) {
		return page.setRecords(baseMapper.selectRoomPage(page, room));
	}

	@Override
	@Transactional
	public boolean saveOrUpdateRoom(Room room) {
		if(room.getId() == null && !this.save(room)){
			return false;
		}

		room.setOrgPosition(room.getOrgPosition()+ "/"+room.getId());
		return this.updateById(room);
	}

	@Override
	public IPage<Room> queryPage(IPage<Room> page, LambdaQueryWrapper<Room> queryWrapper) {
		List<Room> rooms = baseMapper.queryPage(page, queryWrapper);
		return page.setRecords(rooms);
	}

    @Override
    public Boolean delete(AgencyMngDelDTO agencyMngDelDTO) {
        return baseMapper.delete(agencyMngDelDTO);
    }

}
